# Alpha container role 
######################
resource "aws_iam_role" "alpha_iam_role" {
  name = "${var.athens_prefix}-alpha-iam-role"
  assume_role_policy = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Action = "sts:AssumeRole"
        Principal = {
          Service = [ "ecs-tasks.amazonaws.com" ]
        }
        Effect = "Allow"
      }
    ]
  })
}


resource "aws_iam_policy" "alpha_iam_policy" {
  name = "${var.athens_prefix}-alpha-iam-policy"
  policy = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Effect = "Allow"
        Action = [
          "logs:CreateLogGroup",
          "logs:CreateLogStream",
          "logs:DescribeLogStreams",
          "logs:PutLogEvents",
        ]
        "Resource" = "*"
      }
    ]
  })
}

resource "aws_iam_policy" "ecs_ecr_pull" {
  name = "${var.athens_prefix}-allow-ecs-pull-ecr"
  policy = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Effect = "Allow"
        Action = [
          "ecr:GetAuthorizationToken",
          "ecr:BatchGetImage",
          "ecr:GetDownloadUrlForLayer"
        ]
        "Resource" = "*"
      }
    ]
  })
}

resource "aws_iam_role_policy_attachment" "alpha_logs" {
  role        = aws_iam_role.alpha_iam_role.name
  policy_arn  = aws_iam_policy.alpha_iam_policy.arn
}

resource "aws_iam_role_policy_attachment" "ecs_ecr_pull" {
  role        = aws_iam_role.alpha_iam_role.name
  policy_arn  = aws_iam_policy.ecs_ecr_pull.arn
}
